# 
# Synthesis run script generated by Vivado
# 

set TIME_start [clock seconds] 
namespace eval ::optrace {
  variable script "E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.runs/synth_3/top.tcl"
  variable category "vivado_synth"
}

# Try to connect to running dispatch if we haven't done so already.
# This code assumes that the Tcl interpreter is not using threads,
# since the ::dispatch::connected variable isn't mutex protected.
if {![info exists ::dispatch::connected]} {
  namespace eval ::dispatch {
    variable connected false
    if {[llength [array get env XILINX_CD_CONNECT_ID]] > 0} {
      set result "true"
      if {[catch {
        if {[lsearch -exact [package names] DispatchTcl] < 0} {
          set result [load librdi_cd_clienttcl[info sharedlibextension]] 
        }
        if {$result eq "false"} {
          puts "WARNING: Could not load dispatch client library"
        }
        set connect_id [ ::dispatch::init_client -mode EXISTING_SERVER ]
        if { $connect_id eq "" } {
          puts "WARNING: Could not initialize dispatch client"
        } else {
          puts "INFO: Dispatch client connection id - $connect_id"
          set connected true
        }
      } catch_res]} {
        puts "WARNING: failed to connect to dispatch server - $catch_res"
      }
    }
  }
}
if {$::dispatch::connected} {
  # Remove the dummy proc if it exists.
  if { [expr {[llength [info procs ::OPTRACE]] > 0}] } {
    rename ::OPTRACE ""
  }
  proc ::OPTRACE { task action {tags {} } } {
    ::vitis_log::op_trace "$task" $action -tags $tags -script $::optrace::script -category $::optrace::category
  }
  # dispatch is generic. We specifically want to attach logging.
  ::vitis_log::connect_client
} else {
  # Add dummy proc if it doesn't exist.
  if { [expr {[llength [info procs ::OPTRACE]] == 0}] } {
    proc ::OPTRACE {{arg1 \"\" } {arg2 \"\"} {arg3 \"\" } {arg4 \"\"} {arg5 \"\" } {arg6 \"\"}} {
        # Do nothing
    }
  }
}

proc create_report { reportName command } {
  set status "."
  append status $reportName ".fail"
  if { [file exists $status] } {
    eval file delete [glob $status]
  }
  send_msg_id runtcl-4 info "Executing : $command"
  set retval [eval catch { $command } msg]
  if { $retval != 0 } {
    set fp [open $status w]
    close $fp
    send_msg_id runtcl-5 warning "$msg"
  }
}
OPTRACE "synth_3" START { ROLLUP_AUTO }
set_param chipscope.maxJobs 1
OPTRACE "Creating in-memory project" START { }
create_project -in_memory -part xc7a100tfgg676-2

set_param project.singleFileAddWarning.threshold 0
set_param project.compositeFile.enableAutoGeneration 0
set_param synth.vivado.isSynthRun true
set_msg_config -source 4 -id {IP_Flow 19-2162} -severity warning -new_severity info
set_property webtalk.parent_dir E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.cache/wt [current_project]
set_property parent.project_path E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.xpr [current_project]
set_property XPM_LIBRARIES {XPM_CDC XPM_MEMORY} [current_project]
set_property default_lib xil_defaultlib [current_project]
set_property target_language Verilog [current_project]
set_property ip_output_repo e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.cache/ip [current_project]
set_property ip_cache_permissions {read write} [current_project]
OPTRACE "Creating in-memory project" END { }
OPTRACE "Adding files" START { }
read_verilog -library xil_defaultlib {
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/video_stream/axi2bram.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/debounce/debounce_inputs.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/debounce/debouncer.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/dividers/divider_2.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/dividers/divider_4.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/video_stream/frame_read.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hdmi/hdmi_ctrl.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hdmi/hdmi_out.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_am_addhbi.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_lineBubkb.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_lineBucud.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_mac_muibs.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_mac_mujbC.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_mac_mukbM.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_mul_42g8j.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_mul_66fYi.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hls_generated/img_filter_mux_83eOg.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/uart/master_axi.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/video_stream/ov7670_init_regs.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/sccb/ov7670_read.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/video_stream/processing.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/sccb/sccb_ctrl.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/sccb/sccb_read.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/sccb/sccb_write.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/hdmi/tmds_encoder.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/uart/uart_ctrl.v
  E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/imports/hdl/top.v
}
read_ip -quiet E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/ip/clk_wiz_1/clk_wiz_1.xci
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/ip/clk_wiz_1/clk_wiz_1_board.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/ip/clk_wiz_1/clk_wiz_1.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/sources_1/ip/clk_wiz_1/clk_wiz_1_ooc.xdc]

read_ip -quiet E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/ram/ip/ram/ram.xci
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/ram/ip/ram/ram_ooc.xdc]

read_ip -quiet E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/frame_buffer/ip/frame_buffer/frame_buffer.xci
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/frame_buffer/ip/frame_buffer/frame_buffer.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/frame_buffer/ip/frame_buffer/frame_buffer_clocks.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/frame_buffer/ip/frame_buffer/frame_buffer_ooc.xdc]

read_ip -quiet E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/clk_wiz_0/ip/clk_wiz_0/clk_wiz_0.xci
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/clk_wiz_0/ip/clk_wiz_0/clk_wiz_0_board.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/clk_wiz_0/ip/clk_wiz_0/clk_wiz_0.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/clk_wiz_0/ip/clk_wiz_0/clk_wiz_0_ooc.xdc]

read_ip -quiet E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/axi_uartlite_0/ip/axi_uartlite_0/axi_uartlite_0.xci
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/axi_uartlite_0/ip/axi_uartlite_0/axi_uartlite_0_board.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/axi_uartlite_0/ip/axi_uartlite_0/axi_uartlite_0_ooc.xdc]
set_property used_in_implementation false [get_files -all e:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/axi_uartlite_0/ip/axi_uartlite_0/axi_uartlite_0.xdc]

OPTRACE "Adding files" END { }
# Mark all dcp files as not used in implementation to prevent them from being
# stitched into the results of this synthesis run. Any black boxes in the
# design are intentionally left as such for best results. Dcp files will be
# stitched into the design at a later time, either when this synthesis run is
# opened, or when it is stitched into a dependent implementation run.
foreach dcp [get_files -quiet -all -filter file_type=="Design\ Checkpoint"] {
  set_property used_in_implementation false $dcp
}
read_xdc E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/constrs_1/imports/constraints/constraints.xdc
set_property used_in_implementation false [get_files E:/_VivadoProjects/QMTECH_FAM/CMOSCameraArtix7My/CMOSCameraArtix7My.srcs/constrs_1/imports/constraints/constraints.xdc]

set_param ips.enableIPCacheLiteLoad 1
close [open __synthesis_is_running__ w]

OPTRACE "synth_design" START { }
synth_design -top top -part xc7a100tfgg676-2
OPTRACE "synth_design" END { }


OPTRACE "write_checkpoint" START { CHECKPOINT }
# disable binary constraint mode for synth run checkpoints
set_param constraints.enableBinaryConstraints false
write_checkpoint -force -noxdef top.dcp
OPTRACE "write_checkpoint" END { }
OPTRACE "synth reports" START { REPORT }
create_report "synth_3_synth_report_utilization_0" "report_utilization -file top_utilization_synth.rpt -pb top_utilization_synth.pb"
OPTRACE "synth reports" END { }
file delete __synthesis_is_running__
close [open __synthesis_is_complete__ w]
OPTRACE "synth_3" END { }
