set_property CFGBVS VCCO [current_design]
set_property CONFIG_VOLTAGE 3.3 [current_design]
set_property BITSTREAM.CONFIG.UNUSEDPIN PULLUP [current_design]

#############SPI Configurate Setting##################
set_property BITSTREAM.CONFIG.SPI_BUSWIDTH 4 [current_design]
set_property CONFIG_MODE SPIx4 [current_design]
set_property BITSTREAM.CONFIG.CONFIGRATE 50 [current_design]

############## clock and reset define##################
create_clock -period 20.000 -waveform {0.000 5.000} [get_ports CLK50MHz]
set_property PACKAGE_PIN M22 [get_ports CLK50MHz]
set_property IOSTANDARD LVCMOS33 [get_ports CLK50MHz]
###set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets {CLK50MHz_IBUF}]
set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets {MainClock/inst/clk_in1_clk_wiz_1}]


#Buttons
set_property -dict {PACKAGE_PIN H7 IOSTANDARD LVCMOS33} [get_ports RESETn]
#set_property PULLDOWN true [get_ports RESETn]
set_property -dict {PACKAGE_PIN J8 IOSTANDARD LVCMOS33} [get_ports cam_RESETn]
#set_property PULLDOWN true [get_ports cam_RESETn]

#Switches
set_property -dict {PACKAGE_PIN AB24 IOSTANDARD LVCMOS33} [get_ports {SW[0]}]
set_property -dict {PACKAGE_PIN AC24  IOSTANDARD LVCMOS33} [get_ports { SW[1] }];
set_property -dict {PACKAGE_PIN AA24 IOSTANDARD LVCMOS33} [get_ports {SW[2]}]

#LEDs
set_property -dict {PACKAGE_PIN H6 IOSTANDARD LVCMOS33} [get_ports LED0]
set_property -dict {PACKAGE_PIN J6 IOSTANDARD LVCMOS33} [get_ports LED1]
set_property -dict {PACKAGE_PIN G20 IOSTANDARD LVCMOS33} [get_ports LED2]

#UART
#TXD_IN
set_property -dict {PACKAGE_PIN AB26 IOSTANDARD LVCMOS33} [get_ports usb_uart_rxd]
#RXD_OUT
set_property -dict {PACKAGE_PIN AC26 IOSTANDARD LVCMOS33} [get_ports usb_uart_txd]

set_input_delay -clock CLK50MHz -max 2 [get_ports usb_uart_rxd]
set_input_delay -clock CLK50MHz -min 1 [get_ports usb_uart_rxd]
set_output_delay -clock CLK50MHz -max 2 [get_ports usb_uart_txd]
set_output_delay -clock CLK50MHz -min 1 [get_ports usb_uart_txd]

#HDMI
set_property -dict {PACKAGE_PIN C4 IOSTANDARD TMDS_33} [get_ports TMDSn_clk]
set_property -dict {PACKAGE_PIN D4 IOSTANDARD TMDS_33} [get_ports TMDSp_clk]


set_property -dict {PACKAGE_PIN D1 IOSTANDARD TMDS_33} [get_ports {TMDSn[0]}]
set_property -dict {PACKAGE_PIN E1 IOSTANDARD TMDS_33} [get_ports {TMDSp[0]}]


set_property -dict {PACKAGE_PIN E2 IOSTANDARD TMDS_33} [get_ports {TMDSn[1]}]
set_property -dict {PACKAGE_PIN F2 IOSTANDARD TMDS_33} [get_ports {TMDSp[1]}]

set_property -dict {PACKAGE_PIN G1 IOSTANDARD TMDS_33} [get_ports {TMDSn[2]}]
set_property -dict {PACKAGE_PIN G2 IOSTANDARD TMDS_33} [get_ports {TMDSp[2]}]


## OV7670 Camera header pins

##Pmod Header JB
##Sch name = JB1
set_property PACKAGE_PIN W21 [get_ports OV7670_PWDN]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_PWDN]
##Sch name = JB2
set_property PACKAGE_PIN Y21 [get_ports {OV7670_D[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[0]}]
##Sch name = JB3
set_property PACKAGE_PIN K21 [get_ports {OV7670_D[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[2]}]
##Sch name = JB4
set_property PACKAGE_PIN J21 [get_ports {OV7670_D[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[4]}]
##Sch name = JB7
set_property PACKAGE_PIN H26 [get_ports OV7670_RESET]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_RESET]
##Sch name = JB8
set_property PACKAGE_PIN G26 [get_ports {OV7670_D[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[1]}]
##Sch name = JB9
set_property PACKAGE_PIN G25 [get_ports {OV7670_D[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[3]}]
##Sch name = JB10
set_property PACKAGE_PIN W24 [get_ports {OV7670_D[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[5]}]

##Pmod Header JC
##Sch name = JC1
set_property PACKAGE_PIN V23 [get_ports {OV7670_D[6]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[6]}]
##Sch name = JC2
set_property PACKAGE_PIN V21 [get_ports OV7670_XCLK]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_XCLK]
##Sch name = JC3
set_property PACKAGE_PIN W23 [get_ports  OV7670_HREF]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_HREF]
##Sch name = JC4
set_property PACKAGE_PIN V18 [get_ports OV7670_SIOD]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_SIOD]
set_property PULLUP true [get_ports OV7670_SIOD]
##Sch name = JC7
set_property PACKAGE_PIN W18 [get_ports {OV7670_D[7]}]
set_property IOSTANDARD LVCMOS33 [get_ports {OV7670_D[7]}]
##Sch name = JC8
set_property PACKAGE_PIN U22 [get_ports OV7670_PCLK]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_PCLK]
set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets OV7670_PCLK_IBUF]
##Sch name = JC9
set_property PACKAGE_PIN V22 [get_ports OV7670_VSYNC]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_VSYNC]
##Sch name = JC10
set_property PACKAGE_PIN U21 [get_ports OV7670_SIOC]
set_property IOSTANDARD LVCMOS33 [get_ports OV7670_SIOC]


##create_clock -period 10.000 -name CLK50MHz -waveform {0.000 5.000} [get_ports CLK50MHz]
create_clock -period 40.000 -name OV7670_PCLK -waveform {0.000 20.000} [get_ports OV7670_PCLK]
create_generated_clock -name div2/clkb -source [get_ports CLK50MHz] -divide_by 2 [get_pins div2/clkout_reg/Q]
create_generated_clock -name div4/CLK -source [get_ports CLK50MHz] -divide_by 4 [get_pins div4/clkout_reg/Q]
set_false_path -from [get_clocks CLK50MHz] -to [get_clocks OV7670_PCLK]
set_false_path -from [get_clocks CLK50MHz] -to [get_clocks div4/CLK]
set_false_path -from [get_clocks CLK50MHz] -to [get_clocks div2/clkb]

set_input_delay -clock [get_clocks OV7670_PCLK] -min -add_delay 8.000 [get_ports {OV7670_D[*]}]
set_input_delay -clock [get_clocks OV7670_PCLK] -max -add_delay 13.000 [get_ports {OV7670_D[*]}]
set_input_delay -clock [get_clocks OV7670_PCLK] -min -add_delay 8.000 [get_ports OV7670_HREF]
set_input_delay -clock [get_clocks OV7670_PCLK] -max -add_delay 13.000 [get_ports OV7670_HREF]
